
import java.util.*;

/**
 *
 * @author cteam039
 */
public class Fn {

    public static void main(String... args) {
        int points, lines;
        Scanner scan = new Scanner(System.in);
        while (scan.hasNextInt()) {
            iteration(scan);

        }
    }

    public static void iteration(Scanner scan) {
        int points, lines;

        points = scan.nextInt();
        lines = scan.nextInt();
        List<Map<Integer, Graph>> graphs = new ArrayList<Map<Integer, Fn.Graph>>();
        if (points < 2 || lines < 1) {
            System.out.println("NO");
            return;
        }
        for (int i = 0; i < lines; i++) {
            int a = scan.nextInt();
            int b = scan.nextInt();
            
            Map<Integer, Graph> first = null, second = null;
            boolean addedX = false;
            for(Map<Integer, Graph> graph : graphs){
                
                boolean added = insert(graph, a, b);
                
                if(added && !addedX){
                    first = graph;
                    addedX = true;
                }
                if(added && addedX){
                    second = graph;
                    break;
                }
            }
            if(!addedX){
                    Map<Integer, Graph> gr= new HashMap<Integer, Graph>();
                    graphs.add(gr);
                    gr.put(a, new Graph(a));
                    gr.put(b, new Graph(b));
            }
            else {
                if(second != null){
                first.get(a).incide++;
                first.get(b).incide++;
                first.putAll(second);
                }
                int counter = 0;
            for(Graph g: first.values()){
                if(g.incide == 1){
                    counter ++;
                }
            }
            if(counter > 3 ){
                System.out.println("YES");
                return;
            }
            }
        }
        
//        for(List<Graph> list : graphs){
//            int counter = 0;
//            for(Graph g: list){
//                if(g.incide == 1){
//                    counter ++;
//                }
//            }
//            if(counter > 3 ){
//                System.out.println("YES");
//                return;
//            }
//        }
        System.out.println("NO");
        
    }

    public static boolean insert(Map<Integer, Graph> graph, Integer a, Integer b){
        if(graph.keySet().contains(a)){
            if(graph.keySet().contains(b)){
                return true;
            }
            else{
                graph.get(a).incide++;
                graph.put(b, new Graph(b));
                return true;
            }
        }
        else{
            if(graph.keySet().contains(b)){
                graph.get(b).incide++;
                graph.put(a, new Graph(a));
                return true;
            }
            else{
                return false;
            }
        }
    }

    private static class Graph {

        int id;
        int incide;

        public Graph(int id) {
            this.id = id;
            incide = 1;
        }

        @Override
        public boolean equals(Object arg0) {
            if(!(arg0 instanceof Graph)){
                return false;
            }
            return ((Graph)arg0).id == id;
        }

        @Override
        public int hashCode() {
            int hash = 5;
            hash = 79 * hash + this.id;
            return hash;
        }
        
        
    }
}
